## ros-foxy-maliput-dragway 0.1.5

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput_dragway LANGUAGES C CXX VERSION 3.0.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)

find_package(maliput REQUIRED)
find_package(maliput_py REQUIRED)
find_package(pybind11 REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

ament_python_install_package(${PROJECT_NAME})

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)

##############################################################################
# Sources
##############################################################################

add_subdirectory(src)

##############################################################################
# Tests
##############################################################################

if(BUILD_TESTING)
  find_package(ament_cmake_clang_format REQUIRED)
  enable_testing()
  add_subdirectory(test)
  ament_clang_format(CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/.clang-format)
endif()

##############################################################################
# Docs
##############################################################################

if(BUILD_DOCS)
  message(STATUS "Doxygen generation - Enabled")
  find_package(ament_cmake_doxygen REQUIRED)
  ament_doxygen_generate(doxygen_maliput_dragway
    CONFIG_OVERLAY doc/Doxyfile.overlay.in
    DEPENDENCIES maliput
    TEST_ON_WARNS
  )
  add_definitions(-DBUILD_DOCS)
else()
  message(STATUS "Doxygen generation - Disabled")
endif()

##############################################################################
# Export
##############################################################################

ament_environment_hooks("${CMAKE_CURRENT_SOURCE_DIR}/env-hooks/${PROJECT_NAME}.dsv.in")
ament_environment_hooks("${CMAKE_CURRENT_SOURCE_DIR}/env-hooks/${PROJECT_NAME}.sh.in")

install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)

ament_export_dependencies(ament_cmake)
ament_export_dependencies(maliput)
ament_export_dependencies(maliput_py)
ament_export_targets(${PROJECT_NAME}-targets HAS_LIBRARY_TARGET)

ament_package()

=== src/CMakeLists.txt ===
add_subdirectory(bindings)
add_subdirectory(maliput_dragway)
add_subdirectory(maliput_dragway_test_utilities)
add_subdirectory(plugin)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_cmake_pytest REQUIRED)

ament_add_gtest(dragway_test dragway_test.cc)

macro(add_dependencies_to_test target)
    if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
      )

      target_link_libraries(${target}
          maliput::test_utilities
          maliput_dragway::maliput_dragway
      )
    endif()
endmacro()

add_dependencies_to_test(dragway_test)

# TODO(francocipollone): Improve this check by wrapping ament_add_pytest_test() function.
# When sanitizers are activated python scripts are disabled.
if (NOT ${SANITIZERS})
  ament_add_pytest_test(dragway_pytest
    dragway_test.py
    # Avoid pytest from importing the module stub
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
endif()

add_subdirectory(plugin)

=== src/bindings/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

pybind11_add_module(dragway_py dragway_py.cc)

set_target_properties(dragway_py PROPERTIES OUTPUT_NAME "dragway")

target_include_directories(dragway_py
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
)

target_link_libraries(dragway_py
  PRIVATE
    maliput::api
    maliput_dragway::maliput_dragway
    pybind11::module
)

##############################################################################
# Install
##############################################################################

install(TARGETS dragway_py
  DESTINATION "${PYTHON_INSTALL_DIR}/${PROJECT_NAME}"
)

=== src/maliput_dragway/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(SOURCES
  branch_point.cc
  junction.cc
  lane.cc
  road_geometry.cc
  road_network_builder.cc
  segment.cc)

add_library(maliput_dragway ${SOURCES})

add_library(maliput_dragway::maliput_dragway ALIAS maliput_dragway)

set_target_properties(maliput_dragway
  PROPERTIES
    OUTPUT_NAME maliput_dragway
)

target_include_directories(maliput_dragway
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(maliput_dragway
  maliput::api
  maliput::base
  maliput::common
  maliput::geometry_base
)

##############################################################################
# Export
##############################################################################

install(
  TARGETS maliput_dragway
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/maliput_dragway_test_utilities/CMakeLists.txt ===
if(BUILD_TESTING)

set(TEST_UTILS_SOURCES
  fixtures.cc)

add_library(maliput_dragway_test_utilities ${TEST_UTILS_SOURCES})

add_library(maliput_dragway::test_utilities ALIAS maliput_dragway_test_utilities)

target_include_directories(
  maliput_dragway_test_utilities
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(maliput_dragway_test_utilities
  maliput::api
  maliput_dragway::maliput_dragway
)

install(
  TARGETS maliput_dragway_test_utilities
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

endif()

=== src/plugin/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

add_library(road_network road_network.cc)
add_library(maliput_dragway::road_network ALIAS road_network)

set_target_properties(road_network
  PROPERTIES
    OUTPUT_NAME maliput_dragway_road_network
)

target_link_libraries(road_network
  maliput::api
  maliput::base
  maliput::common
  maliput::plugin
  maliput_dragway::maliput_dragway
)

target_include_directories(road_network
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>
)

##############################################################################
# Export
##############################################################################

# Using a different location as this target is a dynamic library
# which will be loaded in runtime as a maliput plugin.
set(PLUGIN_INSTALL_DIR
    lib/maliput_plugins
)

install(
  TARGETS road_network
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
  RUNTIME DESTINATION bin
)

=== test/plugin/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)

ament_add_gtest(road_network_plugin road_network_plugin_test.cc)

macro(add_dependencies_to_test target)
    if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
      )

      # To avoid a false positive when running ubsan the symbols must be exported
      # See https://stackoverflow.com/questions/57361776/use-ubsan-with-dynamically-loaded-shared-libraries
      set_target_properties(${target}
        PROPERTIES
          ENABLE_EXPORTS ON
      )

      set(ROAD_NETWORK_PLUGIN ${CMAKE_INSTALL_PREFIX}/lib/maliput_plugins/)
      target_compile_definitions(${target}
        PRIVATE
          DEF_ROAD_NETWORK_PLUGIN="${ROAD_NETWORK_PLUGIN}"
      )

      target_link_libraries(${target}
          maliput_dragway::maliput_dragway
          maliput::plugin
          maliput::test_utilities
      )
    endif()
endmacro()

add_dependencies_to_test(road_network_plugin)

=== debian/changelog ===
ros-foxy-maliput-dragway (0.1.5-1focal) focal; urgency=high

  * Moves builder's parameters to a separate file. (#80 <https://github.com/maliput/maliput_dragway/issues/80>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Thu, 13 Apr 2023 03:00:00 -0000

ros-foxy-maliput-dragway (0.1.4-1focal) focal; urgency=high

  * Implements plugin interface for providing default parameters. (#79 <https://github.com/maliput/maliput_dragway/issues/79>)
  * Updates triage workflow. (#77 <https://github.com/maliput/maliput_dragway/issues/77>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 12 Dec 2022 03:00:00 -0000

ros-foxy-maliput-dragway (0.1.3-1focal) focal; urgency=high

  * Matches with changes in Maliput: Lane::ToLanePosition. (#76 <https://github.com/maliput/maliput_dragway/issues/76>)
  * Adds triage workflow. (#75 <https://github.com/maliput/maliput_dragway/issues/75>)
  * Improves README. (#74 <https://github.com/maliput/maliput_dragway/issues/74>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Wed, 14 Sep 2022 03:00:00 -0000

ros-foxy-maliput-dragway (0.1.2-1focal) focal; urgency=high

  * Fixes environment hooks. (#73 <https://github.com/maliput/maliput_dragway/issues/73>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Fri, 01 Jul 2022 03:00:00 -0000

ros-foxy-maliput-dragway (0.1.1-1focal) focal; urgency=high

  * add missing dependency on python3-dev to get python.h (#72 <https://github.com/maliput/maliput_dragway/issues/72>)
    * add missing dependency on python3-dev to get python.h
    * Compiles test utilities when BUILD_TESTING flag is on, to match gtest dependency.
    Co-authored-by: Franco Cipollone <mailto:franco.c@ekumenlabs.com>
  * Contributors: Tully Foote

 -- Daniel Stonier <daniel.stonier@tri.global>  Tue, 21 Jun 2022 03:00:00 -0000

ros-foxy-maliput-dragway (0.1.0-1focal) focal; urgency=high

  * Updates package.xml
  * Suppresses old-rule-api-related deprecation warnings. (#71 <https://github.com/maliput/maliput_dragway/issues/71>)
  * Uses doc_depend label. (#70 <https://github.com/maliput/maliput_dragway/issues/70>)
  * Fixes include folder installation. (#69 <https://github.com/maliput/maliput_dragway/issues/69>)
  * Depends on pybind11-dev package via rosdep. (#68 <https://github.com/maliput/maliput_dragway/issues/68>)
  * Uses ros-action-ci in build.yaml workflow. (#67 <https://github.com/maliput/maliput_dragway/issues/67>)
  * Updates license. (#66 <https://github.com/maliput/maliput_dragway/issues/66>)
  * Uses ament_export_targets. (#65 <https://github.com/maliput/maliput_dragway/issues/65>)
  * Removes dashing support. (#64 <https://github.com/maliput/maliput_dragway/issues/64>)
  * Passes the RoadGeometry to the IntersectionBook constructor. (#63 <https://github.com/maliput/maliput_dragway/issues/63>)
  * Adds BUILD_DOCS flag as opt-in flag (#62 <https://github.com/maliput/maliput_dragway/issues/62>)
  * Adds CI badges (#61 <https://github.com/maliput/maliput_dragway/issues/61>)
  * Replaces push by workflow_dispatch event in gcc build. (#60 <https://github.com/maliput/maliput_dragway/issues/60>)
  * Pairs with maliput::plugin::RoadNetworkLoader functor change. (#59 <https://github.com/maliput/maliput_dragway/issues/59>)
  * Fixes MALIPUT_PLUGIN_PATH new path. (#58 <https://github.com/maliput/maliput_dragway/issues/58>)
  * Improves use of maliput plugin architecture. (#57 <https://github.com/maliput/maliput_dragway/issues/57>)
  * Enable doxygen verification. (#56 <https://github.com/maliput/maliput_dragway/issues/56>)
  * Removes tests of the maliput::api bindings and simplifies the dragway tests (#55 <https://github.com/maliput/maliput_dragway/issues/55>)
  * Set up linker properly when using clang in CI. (#54 <https://github.com/maliput/maliput_dragway/issues/54>)
  * Remove references to GnuInstallDir vars. (#53 <https://github.com/maliput/maliput_dragway/issues/53>)
  * Enable foxy (#51 <https://github.com/maliput/maliput_dragway/issues/51>)
  * Fix include style part 2: reorder, fix newlines (#50 <https://github.com/maliput/maliput_dragway/issues/50>)
  * Fix include style part 1: use <> for maliput, pybind11 includes (#49 <https://github.com/maliput/maliput_dragway/issues/49>)
  * Use newer revision of pybind11 (#47 <https://github.com/maliput/maliput_dragway/issues/47>)
  * rosdep update --include-eol-distros (#48 <https://github.com/maliput/maliput_dragway/issues/48>)
  * Upgrade ros-tooling to v0.2.1 (#46 <https://github.com/maliput/maliput_dragway/issues/46>)
  * Uses maliput_documentation instead of maliput-documentation. (#45 <https://github.com/maliput/maliput_dragway/issues/45>)
  * Switches ament_cmake_doxygen to main. (#44 <https://github.com/maliput/maliput_dragway/issues/44>)
  * Optimizes scan-build run in CI. (#43 <https://github.com/maliput/maliput_dragway/issues/43>)
  * Add changelog template (#42 <https://github.com/maliput/maliput_dragway/issues/42>)
  * Makes CI to clone maliput_py repository. (#41 <https://github.com/maliput/maliput_dragway/issues/41>)
  * Points to maliput-documentation for workspace installation. (#40 <https://github.com/maliput/maliput_dragway/issues/40>)
  * Adds scan build workflow on specific label (#38 <https://github.com/maliput/maliput_dragway/issues/38>)
  * Trigger sanitizers workflow if label is added (#37 <https://github.com/maliput/maliput_dragway/issues/37>)
  * Fix clang build because an attribute was passed in before it was initialized. (#36 <https://github.com/maliput/maliput_dragway/issues/36>)
  * Implements inertial_to_backend_frame_translation (#35 <https://github.com/maliput/maliput_dragway/issues/35>)
  * Moves disabled workflows to a different folder. (#34 <https://github.com/maliput/maliput_dragway/issues/34>)
  * Refer to a specific clang version and use lld linker. (#33 <https://github.com/maliput/maliput_dragway/issues/33>)


=== debian/control ===
Source: ros-foxy-maliput-dragway
Section: misc
Priority: optional
Maintainer: Daniel Stonier <daniel.stonier@tri.global>
Build-Depends: debhelper (>= 9.0.0), pybind11-dev, python3-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format <!nocheck>, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-ament-cmake-pytest <!nocheck>, ros-foxy-maliput, ros-foxy-maliput-py, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput-dragway
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, pybind11-dev, python3-dev, ros-foxy-maliput, ros-foxy-maliput-py, ros-foxy-ros-workspace
Description: Maliput Dragway.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput-dragway//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
